<?php
/*
Copyright: © 2009 WebSharks, Inc. ( coded in the USA )
<mailto:support@websharks-inc.com> <http://www.websharks-inc.com/>

Released under the terms of the GNU General Public License.
You should have received a copy of the GNU General Public License,
along with this software. In the main directory, see: /licensing/
If not, see: <http://www.gnu.org/licenses/>.
*/
/*
Direct access denial.
*/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
	exit ("Do not access this file directly.");
/*
This is the function for registering the widget.
Attach to: add_action("widgets_init");
*/
if (!function_exists ("ws_widget__super_tags_register"))
	{
		function ws_widget__super_tags_register ()
			{
				do_action ("ws_widget__super_tags_before_register", get_defined_vars ());
				/**/
				register_widget ("ws_widget__super_tags");
				/**/
				do_action ("ws_widget__super_tags_after_register", get_defined_vars ());
				/**/
				return;
			}
	}
/*
The extended WP_Widget class that handles several things.
*/
if (!class_exists ("ws_widget__super_tags"))
	{
		class ws_widget__super_tags /* < Register this widget class. */
			extends WP_Widget /* See: /wp-includes/widgets.php for further details. */
			{
				function ws_widget__super_tags () /* Builds the classname, id_base, description, etc. */
					{
						$widget_ops = array ("classname" => "super-tags widget_tag_cloud", "description" => $GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["description"]);
						$control_ops = array ("width" => $GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["control_w"], "id_base" => "ws_widget__super_tags");
						/**/
						eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
						do_action ("ws_widget__super_tags_class_before_widget_construction", get_defined_vars (), $this);
						unset ($__refs, $__v); /* Unset defined __refs, __v. */
						/**/
						$this->WP_Widget ($control_ops["id_base"], $GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["name"], $widget_ops, $control_ops);
						/**/
						do_action ("ws_widget__super_tags_class_after_widget_construction", get_defined_vars (), $this);
						/**/
						return;
					}
				/*
				Widget display function. This is where the widget actually does something.
				*/
				function widget ($args = FALSE, $instance = FALSE)
					{
						$options = ws_widget__super_tags_configure_options_and_their_defaults (false, (array)$instance);
						/**/
						eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
						do_action ("ws_widget__super_tags_class_before_widget_display", get_defined_vars (), $this);
						unset ($__refs, $__v); /* Unset defined __refs, __v. */
						/**/
						echo $args["before_widget"]; /* Ok, here we go into this widget.
						/**/
						if (strlen ($options["title"])) /* If there is. */
							echo $args["before_title"] . apply_filters ("widget_title", $options["title"]) . $args["after_title"];
						/**/
						eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
						do_action ("ws_widget__super_tags_class_during_widget_display_before", get_defined_vars (), $this);
						unset ($__refs, $__v); /* Unset defined __refs, __v. */
						/**/
						echo wp_tag_cloud ($options); /* Pass options to the wp_tag_cloud function. */
						/**/
						eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
						do_action ("ws_widget__super_tags_class_during_widget_display_after", get_defined_vars (), $this);
						unset ($__refs, $__v); /* Unset defined __refs, __v. */
						/**/
						echo $args["after_widget"];
						/**/
						do_action ("ws_widget__super_tags_class_after_widget_display", get_defined_vars (), $this);
						/**/
						return;
					}
				/*
				Widget form control function. This is where options are made configurable.
				*/
				function form ($instance = FALSE)
					{
						$options = ws_widget__super_tags_configure_options_and_their_defaults (false, (array)$instance);
						/**/
						eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
						do_action ("ws_widget__super_tags_class_before_widget_form", get_defined_vars (), $this);
						unset ($__refs, $__v); /* Unset defined __refs, __v. */
						/*
						Ok, here is where we need to handle the widget control form. This allows a user to further customize the widget.
						*/
						echo '<label for="' . esc_attr ($this->get_field_id ("title")) . '">Title:</label><br />' . "\n";
						echo '<input class="widefat" id="' . esc_attr ($this->get_field_id ("title")) . '" name="' . esc_attr ($this->get_field_name ("title")) . '" type="text" value="' . format_to_edit ($options["title"]) . '" /><br /><br />' . "\n";
						/**/
						echo '<label for="' . esc_attr ($this->get_field_id ("smallest")) . '">Smallest Font Size ( optional / in pixels ):</label><br />' . "\n";
						echo '<input class="widefat" id="' . esc_attr ($this->get_field_id ("smallest")) . '" name="' . esc_attr ($this->get_field_name ("smallest")) . '" type="text" value="' . format_to_edit ($options["smallest"]) . '" /><br /><br />' . "\n";
						/**/
						echo '<label for="' . esc_attr ($this->get_field_id ("largest")) . '">Largest Font Size ( optional / in pixels ):</label><br />' . "\n";
						echo '<input class="widefat" id="' . esc_attr ($this->get_field_id ("largest")) . '" name="' . esc_attr ($this->get_field_name ("largest")) . '" type="text" value="' . format_to_edit ($options["largest"]) . '" /><br /><br />' . "\n";
						/**/
						echo '<label for="' . esc_attr ($this->get_field_id ("number")) . '">Max Tags To Display ( optional / number > 1 ):</label><br />' . "\n";
						echo '<input class="widefat" id="' . esc_attr ($this->get_field_id ("number")) . '" name="' . esc_attr ($this->get_field_name ("number")) . '" type="text" value="' . format_to_edit ($options["number"]) . '" /><br /><br />' . "\n";
						/**/
						echo '<label for="' . esc_attr ($this->get_field_id ("format")) . '">Format ( optional / flat or list ):</label><br />' . "\n";
						echo '<input class="widefat" id="' . esc_attr ($this->get_field_id ("format")) . '" name="' . esc_attr ($this->get_field_name ("format")) . '" type="text" value="' . format_to_edit ($options["format"]) . '" /><br /><br />' . "\n";
						/**/
						echo '<label for="' . esc_attr ($this->get_field_id ("orderby")) . '">Orderby ( optional / name or count ):</label><br />' . "\n";
						echo '<input class="widefat" id="' . esc_attr ($this->get_field_id ("orderby")) . '" name="' . esc_attr ($this->get_field_name ("orderby")) . '" type="text" value="' . format_to_edit ($options["orderby"]) . '" /><br /><br />' . "\n";
						/**/
						echo '<label for="' . esc_attr ($this->get_field_id ("order")) . '">Order ( optional / ASC, DESC, or RAND ):</label><br />' . "\n";
						echo '<input class="widefat" id="' . esc_attr ($this->get_field_id ("order")) . '" name="' . esc_attr ($this->get_field_name ("order")) . '" type="text" value="' . format_to_edit ($options["order"]) . '" /><br /><br />' . "\n";
						/**/
						echo '<label for="' . esc_attr ($this->get_field_id ("exclude")) . '">Exclude ( optional / comma separated term IDs ):</label><br />' . "\n";
						echo '<input class="widefat" id="' . esc_attr ($this->get_field_id ("exclude")) . '" name="' . esc_attr ($this->get_field_name ("exclude")) . '" type="text" value="' . format_to_edit ($options["exclude"]) . '" /><br /><br />' . "\n";
						/**/
						echo '<label for="' . esc_attr ($this->get_field_id ("include")) . '">Include ( optional / comma separated term IDs ):</label><br />' . "\n";
						echo '<input class="widefat" id="' . esc_attr ($this->get_field_id ("include")) . '" name="' . esc_attr ($this->get_field_name ("include")) . '" type="text" value="' . format_to_edit ($options["include"]) . '" /><br /><br />' . "\n";
						/**/
						echo '<label for="' . esc_attr ($this->get_field_id ("taxonomy")) . '">Taxonomy ( optional / post_tag, category, or link_category ):</label><br />' . "\n";
						echo '<input class="widefat" id="' . esc_attr ($this->get_field_id ("taxonomy")) . '" name="' . esc_attr ($this->get_field_name ("taxonomy")) . '" type="text" value="' . format_to_edit ($options["taxonomy"]) . '" /><br /><br />' . "\n";
						/**/
						echo 'For additional help with these parameters, please read the documentation for the <code><a href="http://codex.wordpress.org/Template_Tags/wp_tag_cloud" target="_blank">wp_tag_cloud() function</a></code>.';
						/**/
						do_action ("ws_widget__super_tags_class_after_widget_form", get_defined_vars (), $this);
						/**/
						echo '<br />' . "\n";
						/**/
						return;
					}
				/*
				Widget update function. This is where an updated instance is configured/stored.
				*/
				function update ($instance = FALSE, $old = FALSE)
					{
						eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
						do_action ("ws_widget__super_tags_class_before_widget_update", get_defined_vars (), $this);
						unset ($__refs, $__v); /* Unset defined __refs, __v. */
						/**/
						$instance = (array)ws_widget__super_tags_trim_deep (stripslashes_deep ($instance));
						return ws_widget__super_tags_configure_options_and_their_defaults (false, $instance);
					}
			}
	}
?>